import axios from 'axios';
import { API_URL_HOME } from '@/shared/api/api-url-home';
import { resultify } from '@/shared/lib/resultify';
import { NiceAxiosError } from '@/shared/@types/error';
import { 
  HomeBannerListParams,
  HomeBannerListResponse
} from '../model/types';
import { 
  useMutation,
  UseMutationOptions
} from '@tanstack/react-query';
import { getHeaderUserAgent } from '@/shared/constants/url';

export const homeBannerList = (params: HomeBannerListParams) => {
  let headerOptions = {
    menuId: 0,
    apiType: 'SELECT'
  };
  let options = {
    headers: {
      'X-User-Agent': getHeaderUserAgent(headerOptions)
    }
  };
  return resultify(
    axios.post<HomeBannerListResponse>(API_URL_HOME.homeBannerList(), params, options),
  );
};

export const useHomeBannerListMutation = (options?: UseMutationOptions<HomeBannerListResponse, NiceAxiosError, HomeBannerListParams>) => {
  const mutation = useMutation<HomeBannerListResponse, NiceAxiosError, HomeBannerListParams>({
    ...options,
    mutationFn: (params: HomeBannerListParams) => homeBannerList(params),
  });

  return {
    ...mutation,
  };
};
